You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.
 
 
 
 
 
 

786 line
19 KiB

  1. #!/bin/bash
  2. # If not running interactively, don't do anything
  3. [[ $- != *i* ]] && return
  4. ##########################################
  5. null(){
  6. "$@" >/dev/null 2>&1
  7. }
  8. __try_exec(){
  9. type $1 >/dev/null 2>&1 && "$@"
  10. }
  11. ##########################
  12. # system type
  13. alias ismsys=false
  14. alias iscygwin=false
  15. alias iswindows=false
  16. alias isdarwin=false
  17. alias islinux=false
  18. alias with_coreutils=false # for mac
  19. case `uname` in
  20. (MINGW*) alias ismsys=true ;;
  21. (CYGWIN*) alias iscygwin=true ;;
  22. (Darwin*) alias isdarwin=true ;;
  23. (Linux*) alias islinux=true ;;
  24. esac
  25. null ls --version && alias with_coreutils=true
  26. ( ismsys || iscygwin ) && alias iswindows=true
  27. #################################
  28. if false iswindows
  29. then
  30. export PAGER='tr -d \\r | less'
  31. else
  32. export PAGER="less"
  33. fi
  34. export LESS="-iRMX"
  35. if null type vim
  36. then
  37. export EDITOR=vim
  38. else
  39. export EDITOR=vi
  40. fi
  41. export LANG=ja_JP.UTF-8
  42. export LC_MESSAGES=C
  43. # export CDPATH=".:~"
  44. export VISUAL="$EDITOR"
  45. export GIT_PAGER="less -F"
  46. export GIT_EDITOR="$EDITOR"
  47. if test -n "$TMUX" && \
  48. echo $TERM | grep screen >/dev/null 2>&1 && \
  49. tmux display -p '#{client_termname}' | grep 256color >/dev/null 2>&1
  50. then
  51. TERM=screen-256color
  52. fi
  53. test -z "$TMP" && export TMP=/tmp/${USER}-tmp
  54. mkdir -p "$TMP"
  55. ! iswindows && null type stty && {
  56. stty stop undef # unbind C-s to stop displaying output
  57. # stty erase '^h'
  58. }
  59. if iswindows; then
  60. # export PS1=" \[\e[32m\]\u@\H \[\e[33m\]\w\[\e[0m\] \d \t\n\s \# \j \$ "
  61. # export PS1=" [\[\e[33m\]\w\[\e[0m\]]\n\[\e[32m\]\u@\H\[\e[0m\] \d \t \s.\v\nhist:\# jobs:\j \$ "
  62. export USER=$USERNAME
  63. fi
  64. _tmux_prefs(){
  65. null type tmux || return 1
  66. tmux set -g mode-keys vi
  67. }
  68. if test -d ~/dbx
  69. then
  70. export CHIT_PATH="$HOME/dbx/.chit"
  71. fi
  72. #######################
  73. iswindows && alias tty="echo cmd.exe"
  74. type fortune >/dev/null 2>&1 && {
  75. fortune
  76. echo
  77. fortune -o
  78. echo
  79. }
  80. uname -a
  81. echo TERM $TERM $(tput colors) colors connected to $(tty), \
  82. running $BASH $BASH_VERSION
  83. if test -n "$TMUX"
  84. then
  85. tmux display -p 'Using tmux #S:#I:#W.#P, client is #{client_termname}' \
  86. 2>/dev/null
  87. echo
  88. fi
  89. ###################################
  90. # some aliases and functions
  91. ( ! with_coreutils && isdarwin ) || test "$TERM" == dumb || \
  92. _coloroption=" --color=auto"
  93. ( ! with_coreutils && isdarwin ) || iswindows || \
  94. _timeoption=" --time-style=long-iso"
  95. ( ! with_coreutils && isdarwin ) || _hideoption=" --hide=[A-Z]*" # do not use
  96. _timeformat_iso="%Y-%m-%dT%H:%M:%S%z"
  97. _timeformat_rfc2822="%a, %d %b %Y %T %z"
  98. alias ls="ls -hCF${_coloroption}${_timeoption}"
  99. # export GREP_OPTIONS=""
  100. alias gr="grep -n --color=always"
  101. iswindows && alias grep="grep -n"
  102. # alias ll="ls -l"
  103. # alias la="ls -A"
  104. # alias lla="ls -Al"
  105. alias less="less -F"
  106. null type emacs && alias em="emacs -nw"
  107. null type vim && alias vi=vim
  108. alias pstree="LANG=C pstree"
  109. alias cp="cp -v"
  110. alias mv="mv -v"
  111. alias rm="rm -v"
  112. alias psaux="ps auxww"
  113. alias q=exit
  114. null type e3em && alias e3=e3em
  115. #alias dirs="dirs -v -l | \grep -v \$(printf '%s$' \$PWD)"
  116. alias po=popd
  117. alias pu=pushd
  118. alias sudo="sudo " # use aliases through sudo
  119. alias sudoe="sudoedit"
  120. alias halt="sudo halt"
  121. alias reboot="sudo reboot"
  122. null type dbus-send && {
  123. alias suspend="dbus-send --system --print-reply --dest=org.freedesktop.UPower \
  124. /org/freedesktop/UPower org.freedesktop.UPower.Suspend"
  125. alias hibernate="dbus-send --system --print-reply --dest=org.freedesktop.UPower \
  126. /org/freedesktop/UPower org.freedesktop.UPower.Hibernate"
  127. }
  128. alias rand="echo \$RANDOM"
  129. null type file-roller && alias xunp="file-roller -h"
  130. null type paco && alias pc="sudo \paco -D"
  131. alias pycalc="python -i -c 'from math import *' "
  132. null type python3 && alias py3=python3
  133. null type python2 && alias py2=python2
  134. alias _reloadrc="test -f ~/.bashrc && source ~/.bashrc"
  135. # alias mytime="date +%Y%m%d-%H%M%S"
  136. alias sh="ENV=$HOME/.shrc PS1=\$\ PROMPT_COMMAND="" sh"
  137. # type trash >/dev/null 2>&1 && alias rm=trash
  138. null type mpg123 && alias mpg123="mpg123 -C -v --title"
  139. null type xmms2 && alias xm="xmms2"
  140. #export PLAYER="mpg123 -C -v --title"
  141. null type screen && alias screen="screen -e^z^z"
  142. #alias zcd="cd \`zenity --file-selection --directory\`"
  143. null type gtags && alias gtags="gtags --verbose"
  144. null type htags && alias htags="htags --xhtml --symbol --line-number \
  145. --frame --alphabet --verbose"
  146. null type aunpack && alias aunp=aunpack
  147. null type lv && alias lv="lv|less"
  148. isdarwin && alias updatedb="LC_ALL=C updatedb"
  149. # pad
  150. alias pad=notepad
  151. null type gedit && alias pad=gedit
  152. null type leafpad && alias pad=leafpad
  153. isdarwin && alias pad="open -e"
  154. null type wicd-curses && alias wic=wicd-curses
  155. null type wicd-cli && alias wil="wicd-cli -y -l | head"
  156. #alias wicn="wicd-cli -y -c -n"
  157. wicn(){
  158. if test $# -eq 0
  159. then
  160. local num
  161. wicd-cli -y -l | head
  162. echo -n "input num: "
  163. read num
  164. test -n "$num" && wicd-cli -y -c -n $num
  165. else
  166. wicd-cli -y -c -n $1
  167. fi
  168. }
  169. for f in /usr/share/vim/vimcurrent/macros/less.sh \
  170. /usr/share/vim/vim73/macros/less.sh \
  171. /usr/share/vim/vim72/macros/less.sh
  172. do
  173. test -f $f && alias vl=$f && break
  174. done
  175. null type yaourt && alias yt=yaourt
  176. null type pacman-color && {
  177. alias pacman=pacman-color
  178. export pacman_program=pacman-color # used by pacmatic
  179. export PACMAN=pacman-color # used by yaourt
  180. }
  181. null type pacmatic && {
  182. alias pacman="pacmatic"
  183. export PACMAN="pacmatic"
  184. }
  185. null type apt-get && {
  186. alias aupgrade="sudo apt-get autoremove --yes && \
  187. sudo apt-get update --yes && sudo apt-get upgrade --yes"
  188. alias aptin="apt-get install"
  189. alias aptsearch="apt-cache search"
  190. alias aptshow="apt-cache show"
  191. }
  192. null type port && {
  193. alias port="port -v"
  194. alias pupgrade="sudo port -v selfupdate && \
  195. { sudo port -v upgrade outdated; }"
  196. }
  197. if iscygwin; then
  198. null type windate || \
  199. alias windate="/c/Windows/System32/cmd.exe //c 'echo %DATE%-%TIME%'"
  200. alias cygsu="cygstart /cygwinsetup.exe"
  201. alias emacs="CYGWIN=tty emacs -nw"
  202. alias ls="ls -CFG $(iswindows || test "$TERM" = dumb || echo --color=auto)"
  203. fi
  204. g(){
  205. if test $# -eq 0 && null type git-info
  206. then
  207. git info
  208. else
  209. git "$@"
  210. fi
  211. }
  212. if null type _git
  213. then
  214. # enable programmable completion for g
  215. complete -o bashdefault -o default -o nospace -F _git g 2>/dev/null \
  216. || complete -o default -o nospace -F _git g
  217. fi
  218. alias setup.py="sudo python3 setup.py install --record files.txt"
  219. man() {
  220. env \
  221. LESS_TERMCAP_mb=$(printf "\e[1;35m") \
  222. LESS_TERMCAP_md=$(printf "\e[1;31m") \
  223. LESS_TERMCAP_me=$(printf "\e[0m") \
  224. LESS_TERMCAP_se=$(printf "\e[0m") \
  225. LESS_TERMCAP_so=$(printf "\e[1;44;33m") \
  226. LESS_TERMCAP_ue=$(printf "\e[0m") \
  227. LESS_TERMCAP_us=$(printf "\e[1;32m") \
  228. man "$@"
  229. }
  230. scr(){
  231. _tformat="%Y%m%d-%H%M%S%z"
  232. _file=`date +${_tformat}`.script
  233. SCRIPT=${_file} script ${_file} "$@"
  234. }
  235. netwait(){
  236. while ! ping -c 1 -t 1 example.com
  237. do
  238. true
  239. done
  240. echo network works.
  241. }
  242. cd(){
  243. if test $# -eq 0
  244. then
  245. pushd ~/ >/dev/null
  246. elif test $1 = -
  247. then
  248. local pwd="$PWD"
  249. command cd $OLDPWD
  250. pushd -n "$pwd" >/dev/null # stack last dir
  251. elif ! test -d "$1"
  252. then
  253. echo `basename ${SHELL}`: cd: "$1": No such file or directory 1>&2
  254. return 1
  255. else
  256. pushd "$1" >/dev/null
  257. fi
  258. __dirs_rm_dup "$PWD"
  259. echo "$PWD"
  260. }
  261. __dirs_rm_dup(){
  262. for d in "$@"
  263. do
  264. local next="$(__realpath --strip "$d")"
  265. for l in $(\dirs -v -l | cut -d $'\n' -f 2- | \
  266. \grep -x " *[0-9]\+ \+${next}" | \grep -o "^ *[0-9]\+ " | tac)
  267. do
  268. popd +$l -n >/dev/null
  269. done
  270. done
  271. }
  272. __realpath(){
  273. if type realpath >/dev/null 2>&1
  274. then
  275. command realpath "$@"
  276. else
  277. while ! test -d $1
  278. do
  279. shift
  280. done
  281. local d="$OLDPWD"
  282. command cd "$1"
  283. echo "$PWD"
  284. command cd "$d"
  285. fi
  286. }
  287. dh(){
  288. if test $# -eq 0
  289. then
  290. dirs -v -l
  291. else
  292. local dir="$(dirs -v -l | \grep "^ *$1 \+" | sed "s/^ *[0-9]* *//g")"
  293. cd "$dir"
  294. fi
  295. }
  296. input(){
  297. local foo
  298. stty -echo
  299. read foo
  300. stty echo
  301. echo $foo
  302. }
  303. tmux(){
  304. if test $# -eq 0
  305. then
  306. (cd ~; command tmux start;)
  307. if command tmux has -t main
  308. then
  309. command tmux attach -t main
  310. else
  311. (cd ~; command tmux new -s main;)
  312. fi
  313. else
  314. command tmux "$@"
  315. fi
  316. }
  317. mcrypt-stream(){
  318. test $# -eq 2 || return 1
  319. case $1 in
  320. en)
  321. mcrypt --key $2 | base64 ;;
  322. de)
  323. base64 -d | mcrypt -d --key $2 ;;
  324. esac
  325. }
  326. gpg-stream(){
  327. test $# -eq 2 || return 1
  328. case $1 in
  329. en)
  330. gpg --passphrase $2 -c --batch |base64 ;;
  331. de)
  332. base64 -d|gpg --passphrase $2 -d --batch ;;
  333. esac
  334. }
  335. dgpg(){
  336. if test "$1" = help || test -z "$2"
  337. then
  338. echo "dgpg: dgpg <en|de> <src-suffix> [<dst-suffix>]" 1>&2
  339. return
  340. fi
  341. local srcs="$2"
  342. local dsts="$3"
  343. test -z "$dsts" && dsts="${srcs}.out"
  344. local pw
  345. echo -n "dgpg pw: "
  346. read -s pw
  347. echo ""
  348. test -z "$pw" && return 1
  349. for f in *${srcs}
  350. do
  351. local d="$(basename "$f" "${srcs}")${dsts}"
  352. echo -n "Processing $f to $d..."
  353. if test -d "$f"
  354. then
  355. echo "`printf 'failed (%s is directory)' $f`"
  356. elif test -f "$d"
  357. then
  358. echo "`printf 'failed (%s is already exists)' $d`"
  359. elif <"$f" gpg-stream $1 $pw >"$d" 2>/dev/null
  360. then
  361. echo "done"
  362. else
  363. echo "failed"
  364. test -f "$d" && rm "$d"
  365. fi
  366. done
  367. }
  368. alias enst="gpg-stream en"
  369. alias dest="gpg-stream de"
  370. showinfo(){
  371. echo "Japanese letters are 表示可能"
  372. __try_exec diskinfo
  373. ! isdarwin && test -n "${DISPLAY}" && {
  374. __try_exec xrandr | \grep --color=never ^Screen
  375. }
  376. iswindows || __try_exec finger $USER
  377. LANG=C __try_exec id
  378. __try_exec xset q
  379. }
  380. x(){
  381. if [[ -z $DISPLAY ]] && ! [[ -e /tmp/.X11-unix/X0 ]] && (( EUID )); then
  382. #mkdir -p ~/.my/log
  383. # nohup startx >~/.my/log/xorg.log 2>&1 &
  384. # exit
  385. exec startx
  386. else
  387. echo "X cant be started! Another X is already running?" 1>&2
  388. fi
  389. }
  390. bak(){
  391. for file in "$@"
  392. do
  393. cp -v ${file} ${file}.bak
  394. done
  395. }
  396. di(){
  397. if type colordiff >/dev/null 2>&1 && test $TERM != dumb
  398. then
  399. local diffcmd=colordiff
  400. else
  401. local diffcmd=diff
  402. fi
  403. ${diffcmd} -u "$@" | ${PAGER}
  404. }
  405. tb(){
  406. local tb="$HOME/.my/tb"
  407. mkdir -p "$tb"
  408. for file in "$@"
  409. do
  410. mv -t "$tb" "$file"
  411. done
  412. }
  413. mkcd(){
  414. mkdir -p $1
  415. cd $1
  416. }
  417. if test -n "$TMUX" && null type reattach-to-user-namespace
  418. then
  419. alias pbpaste="reattach-to-user-namespace pbpaste"
  420. alias pbcopy="reattach-to-user-namespace pbcopy"
  421. fi
  422. catclip(){
  423. if iswindows
  424. then
  425. cat /dev/clipboard | tr -d \\r
  426. elif isdarwin
  427. then
  428. pbpaste
  429. else
  430. xclip -o -selection "clipboard"
  431. fi
  432. }
  433. setclip(){
  434. if test $# -eq 0
  435. then
  436. exec 3<&0
  437. else
  438. exec 3<<__EOF__
  439. `cat "$@"`
  440. __EOF__
  441. fi
  442. if iswindows
  443. then
  444. 0<&3 sed -e 's/$/\r/' | tee /dev/clipboard
  445. elif isdarwin
  446. then
  447. pbcopy 0<&3
  448. else
  449. 0<&3 xclip -i -f -selection "primary" | \
  450. xclip -i -f -selection "clipboard"
  451. fi
  452. exec 3<&-
  453. }
  454. open_file(){
  455. if iswindows
  456. then
  457. cmd.exe //c start "" "$@"
  458. elif isdarwin
  459. then
  460. touch "$@"
  461. open "$@"
  462. elif islinux
  463. then
  464. touch "$@"
  465. if null type pcmanfm; then
  466. LC_MESSAGES= pcmanfm "$@"
  467. else
  468. LC_MESSAGES= xdg-open "$@" &
  469. fi
  470. else
  471. cat "$@"
  472. fi
  473. }
  474. o(){
  475. if test $# -eq 0
  476. then
  477. open_file .
  478. else
  479. for f in "$@"
  480. do
  481. open_file "$(realpath "$f")"
  482. done
  483. fi
  484. }
  485. convmv-sjis2utf8-test(){
  486. convmv -r -f sjis -t utf8 *
  487. }
  488. convmv-sjis2utf8-notest(){
  489. convmv -r -f sjis -t utf8 * --notest
  490. }
  491. #Change ANSI Colors
  492. _chengecolors(){
  493. echo -e \
  494. "\e]P0000000" \
  495. "\e]P1cd0000" \
  496. "\e]P200cd00" \
  497. "\e]P3cdcd00" \
  498. "\e]P41e90ff" \
  499. "\e]P5cd00cd" \
  500. "\e]P600cdcd" \
  501. "\e]P7353535" \
  502. "\e]P8666666" \
  503. "\e]P9ff9999" \
  504. "\e]Pa99ff99" \
  505. "\e]Pbffff99" \
  506. "\e]Pc9999ff" \
  507. "\e]Pdff99ff" \
  508. "\e]Pe99ffff" \
  509. "\e]Pfffffff"
  510. }
  511. # printf "\e]P7353535" \
  512. _colors(){
  513. echo -e \
  514. "\e[30mBlack" \
  515. "\e[31mRed" \
  516. "\e[32mGreen" \
  517. "\e[33mYellow" \
  518. "\e[34mBlue" \
  519. "\e[35mMagenta" \
  520. "\e[36mCyan" \
  521. "\e[37mWhite"
  522. echo -e \
  523. "\e[30;1mBright Black" \
  524. "\e[31;1mBright Red" \
  525. "\e[32;1mBright Green" \
  526. "\e[33;1mBright Yellow" \
  527. "\e[34;1mBright Blue" \
  528. "\e[35;1mBright Magenta" \
  529. "\e[36;1mBright Cyan" \
  530. "\e[37;1mBright White\n" \
  531. "\e[0m"
  532. }
  533. winln(){
  534. # for windose make link (actually junction)
  535. if test $# -eq 0
  536. then
  537. {
  538. echo "usage: winln TARGET LINK_NAME"
  539. echo "Create a link to TARGET with the name LINK_NAME \
  540. (that is, TARGET must already exist)."
  541. echo "About other features run 'junction'."
  542. } 1>&2
  543. return 1
  544. else
  545. junction "$2" "$1"
  546. fi
  547. }
  548. __my_moc_state(){
  549. type mocp >/dev/null 2>&1 || return
  550. test "`mocp -Q %state 2>/dev/null`" == PLAY || return
  551. printf "$1" "`mocp -Q %title 2>/dev/null`"
  552. }
  553. __my_parse_svn_branch() {
  554. local LANG=C
  555. local svn_url=$(svn info 2>/dev/null | sed -ne 's#^URL: ##p')
  556. local svn_repository_root=$(svn info 2>/dev/null | \
  557. sed -ne 's#^Repository Root: ##p')
  558. echo ${svn_url} | sed -e 's#^'"${svn_repository_root}"'##g' | \
  559. awk '{print $1}'
  560. }
  561. __my_svn_ps1(){
  562. if svn status >/dev/null 2>&1
  563. then
  564. local svn_branch=$(__my_parse_svn_branch)
  565. test -n "${svn_branch}" && printf "$1" "{$svn_branch}"
  566. fi
  567. }
  568. __my_battery_status(){
  569. local dir=/sys/class/power_supply/BAT0
  570. if test -d $dir && test -r $dir/status && test -r $dir/charge_full && \
  571. test -r $dir/charge_now
  572. then
  573. local st=$(cat $dir/status)
  574. local full=$(cat $dir/charge_full)
  575. local now=$(cat $dir/charge_now)
  576. local rate=$(expr $now \* 100 / $full)
  577. printf "$1" "${st}:${rate}%"
  578. fi
  579. }
  580. alias bat='__my_battery_status %s\\n'
  581. ip-address(){
  582. type ip >/dev/null 2>&1 || return 1
  583. local ip=$(LANG=C ip addr show scope global | \
  584. \grep --color=never --only-matching 'inet [^ ]*' | cut -d " " -f 2)
  585. test -n "$ip" && printf $1 $ip
  586. }
  587. __my_ps1_script(){
  588. local last=$?
  589. test -n "$SCRIPT" && echo "${__my_c5}SCR${__my_cdef} "
  590. return $last
  591. }
  592. __my_ps1_scale(){
  593. local last=$?
  594. echo "[LC:${LINES}x${COLUMNS}]"
  595. return $last
  596. }
  597. __my_ps1_tmux(){
  598. local last=$?
  599. null type tmux || return $last
  600. local tmuxc="$(tmux display -p '#S:#I:#W.#P' 2>/dev/null)"
  601. test -n "$TMUX" && echo "[TMUX:$tmuxc]"
  602. return $last
  603. }
  604. __my_ps1_moc(){
  605. local last=$?
  606. __my_moc_state "[MOC:%s]"
  607. return $last
  608. }
  609. for f in /usr/share/git/git-prompt.sh \
  610. /opt/local/share/doc/git-core/contrib/completion/git-prompt.sh
  611. do
  612. test -r $f && . $f && break
  613. done
  614. GIT_PS1_SHOWDIRTYSTATE=t
  615. GIT_PS1_SHOWUPSTREAM=t
  616. __my_ps1_git(){
  617. local last=$?
  618. null type __git_ps1 || return $last
  619. null __gitdir || return $last
  620. __git_ps1 "[GIT:$(__try_exec git config --get user.name):%s]"
  621. return $last
  622. }
  623. __my_ps1_ipaddr(){
  624. local last=$?
  625. ! iswindows && ip-address [Addr:%s]
  626. return $last
  627. }
  628. __my_ps1_bttry(){
  629. local last=$?
  630. local bst="${TMP}/batterystatus"
  631. if test -z "$DISPLAY" && ! iswindows
  632. then
  633. test -f $bst && local bstr="$(cat $bst)"
  634. test -n "$bstr" && ! echo $bstr | grep 100 >/dev/null 2>&1 && \
  635. echo "[Battery:$bstr]"
  636. __my_battery_status %s >$bst &
  637. fi
  638. return $last
  639. }
  640. __my_ps1_dirs(){
  641. dirs | wc -l
  642. }
  643. __my_ps1_jobs(){
  644. jobs | wc -l
  645. }
  646. if test "$TERM" != dumb
  647. then
  648. __my_c1="\[\e[1;31m\]" # color for PWD
  649. __my_c2="\[\e[0;36m\]" # color for user
  650. __my_c3="\[\e[1;30m\]" # color for OLDPWD
  651. if test "`hostname`" = arch-aspireone; then __my_c4="\[\e[1;34m\]"
  652. elif test "`hostname`" = darwin-mba.local; then __my_c4="\[\e[1;33m\]"
  653. elif test "`hostname`" = newkiwi; then __my_c4="\[\e[1;35m\]"
  654. else __my_c4="\[\e[1;32m\]" # color for ::
  655. fi
  656. __my_c5="\[\e[30;47m\]" # color for SCR
  657. __my_cdef="\[\e[0m\]"
  658. fi
  659. _PS1="\
  660. ${__my_c4}:: ${__my_cdef}[${__my_c2}\u@\H${__my_cdef}:${__my_c1}\w/${__my_cdef}]\$(__my_ps1_scale)\$(__my_ps1_git)\$(__my_ps1_bttry)\$(__my_ps1_ipaddr)\$(__my_ps1_moc)\n\
  661. ${__my_c4}:: ${__my_cdef}l${SHLVL}n\#j\js\$? \D{%T} $(__my_ps1_script)\$ "
  662. PS1=$_PS1
  663. __my_set_title(){
  664. title="$(echo $@)"
  665. case $TERM in
  666. (rxvt*|xterm*|aterm|screen*)
  667. test -t 1 &&
  668. test -n "$DISPLAY" &&
  669. test -z "$EMACS" &&
  670. echo -n -e "\033]0;${title}\007"
  671. ;;
  672. esac
  673. }
  674. PROMPT_COMMAND="__my_set_title \${USER}@\${HOSTNAME}\ \${PWD}"
  675. # copied from https://wiki.archlinux.org/index.php/X_resources
  676. invader(){
  677. # ANSI color scheme script featuring Space Invaders
  678. #
  679. # Original: http://crunchbanglinux.org/forums/post/126921/#p126921
  680. # Modified by lolilolicon
  681. #
  682. f=3 b=4
  683. for j in f b; do
  684. for i in {0..7}; do
  685. printf -v $j$i %b "\e[${!j}${i}m"
  686. done
  687. done
  688. bld=$'\e[1m'
  689. rst=$'\e[0m'
  690. cat << EOF
  691. $f1 ▀▄ ▄▀ $f2 ▄▄▄████▄▄▄ $f3 ▄██▄ $f4 ▀▄ ▄▀ $f5 ▄▄▄████▄▄▄ $f6 ▄██▄ $rst
  692. $f1 ▄█▀███▀█▄ $f2███▀▀██▀▀███ $f3▄█▀██▀█▄ $f4 ▄█▀███▀█▄ $f5███▀▀██▀▀███ $f6▄█▀██▀█▄$rst
  693. $f1█▀███████▀█ $f2▀▀███▀▀███▀▀ $f3▀█▀██▀█▀ $f4█▀███████▀█ $f5▀▀███▀▀███▀▀ $f6▀█▀██▀█▀$rst
  694. $f1▀ ▀▄▄ ▄▄▀ ▀ $f2 ▀█▄ ▀▀ ▄█▀ $f3▀▄ ▄▀ $f4▀ ▀▄▄ ▄▄▀ ▀ $f5 ▀█▄ ▀▀ ▄█▀ $f6▀▄ ▄▀$rst
  695. $bld$f1▄ ▀▄ ▄▀ ▄ $f2 ▄▄▄████▄▄▄ $f3 ▄██▄ $f4▄ ▀▄ ▄▀ ▄ $f5 ▄▄▄████▄▄▄ $f6 ▄██▄ $rst
  696. $bld$f1█▄█▀███▀█▄█ $f2███▀▀██▀▀███ $f3▄█▀██▀█▄ $f4█▄█▀███▀█▄█ $f5███▀▀██▀▀███ $f6▄█▀██▀█▄$rst
  697. $bld$f1▀█████████▀ $f2▀▀▀██▀▀██▀▀▀ $f3▀▀█▀▀█▀▀ $f4▀█████████▀ $f5▀▀▀██▀▀██▀▀▀ $f6▀▀█▀▀█▀▀$rst
  698. $bld$f1 ▄▀ ▀▄ $f2▄▄▀▀ ▀▀ ▀▀▄▄ $f3▄▀▄▀▀▄▀▄ $f4 ▄▀ ▀▄ $f5▄▄▀▀ ▀▀ ▀▀▄▄ $f6▄▀▄▀▀▄▀▄$rst
  699. $f7▌$rst
  700. $f7▌$rst
  701. $f7 ▄█▄ $rst
  702. $f7▄█████████▄$rst
  703. $f7▀▀▀▀▀▀▀▀▀▀▀$rst
  704. EOF
  705. }
  706. #/etc/lsb-release